
// MFC_BLUETOOTH_TESTDlg.cpp :  
//

#include "stdafx.h"
#include "MFC_BLUETOOTH_TEST.h"
#include "MFC_BLUETOOTH_TESTDlg.h"
#include "afxdialogex.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMFC_BLUETOOTH_TESTDlg ȭ 



CMFC_BLUETOOTH_TESTDlg::CMFC_BLUETOOTH_TESTDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_MFC_BLUETOOTH_TEST_DIALOG, pParent),
	m_pCBluetoothRadioManager(NULL),
	m_pCBluetoothDeviceManager(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFC_BLUETOOTH_TESTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMFC_BLUETOOTH_TESTDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CMFC_BLUETOOTH_TESTDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMFC_BLUETOOTH_TESTDlg::OnBnClickedButton2)
	ON_LBN_SELCHANGE(IDC_LIST1, &CMFC_BLUETOOTH_TESTDlg::OnLbnSelchangeList1)
	ON_LBN_SELCHANGE(IDC_LIST2, &CMFC_BLUETOOTH_TESTDlg::OnLbnSelchangeList2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMFC_BLUETOOTH_TESTDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CMFC_BLUETOOTH_TESTDlg ޽ ó

BOOL CMFC_BLUETOOTH_TESTDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	//  ȭ   մϴ.   α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ.  /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CMFC_BLUETOOTH_TESTDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮԴϴ.

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CMFC_BLUETOOTH_TESTDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMFC_BLUETOOTH_TESTDlg::OnBnClickedButton1()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	m_pCBluetoothRadioManager = NULL;
	m_pCBluetoothDeviceManager = NULL;

	CListBox *pList = (CListBox*)GetDlgItem(IDC_LIST1);

	if (!pList->GetSafeHwnd())
		return;
	
	while (pList->GetCount())
		pList->DeleteString(0);

	for (int i = 0; i < bm.GetRadioSize(); ++i)
	{
		CBluetoothRadioManager *pCBluetoothRadioManager = bm.GetRadio(i);

		if (pCBluetoothRadioManager != NULL)
		{
			pList->InsertString(i, pCBluetoothRadioManager->GetName());
			pList->SetItemDataPtr(i, pCBluetoothRadioManager);
		}
	}
}

void CMFC_BLUETOOTH_TESTDlg::OnBnClickedButton2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (m_pCBluetoothDeviceManager == NULL)
		return;

	if (m_pCBluetoothDeviceManager->Connect())
	{
		//BYTE buf[4096] = { 0, };

		CString strBuf;
		static UINT dTryCnt = 0;
		strBuf.Format(_T("kknd send : %d\r\n"), ++dTryCnt);

		m_pCBluetoothDeviceManager->Send(CT2A(strBuf), strBuf.GetLength());
	}
}

void CMFC_BLUETOOTH_TESTDlg::OnBnClickedButton3()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	if (m_pCBluetoothDeviceManager == NULL)
		return;

	m_pCBluetoothDeviceManager->Close();
}

void CMFC_BLUETOOTH_TESTDlg::OnLbnSelchangeList1()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	m_pCBluetoothRadioManager = NULL;

	CListBox *pList = (CListBox*)GetDlgItem(IDC_LIST1);

	if (!pList->GetSafeHwnd())
		return;

	int pos = pList->GetCurSel();

	if (pos < 0)
		return;

	CBluetoothRadioManager *pCBluetoothRadioManager = reinterpret_cast<CBluetoothRadioManager*>(pList->GetItemDataPtr(pos));

	if (pCBluetoothRadioManager == NULL)
		return;

	CListBox *pList2 = (CListBox*)GetDlgItem(IDC_LIST2);

	if (!pList2->GetSafeHwnd())
		return;
	
	while (pList2->GetCount())
		pList2->DeleteString(0);

	UINT dIndex = 0;
	for (int i = 0; i < pCBluetoothRadioManager->GetDeviceSize(); ++i)
	{
		CBluetoothDeviceManager *pCBluetoothDeviceManager = pCBluetoothRadioManager->GetDevice(i);

		if (pCBluetoothDeviceManager != NULL)
		{
			pList2->InsertString(dIndex, pCBluetoothDeviceManager->GetName());
			pList2->SetItemDataPtr(dIndex, pCBluetoothDeviceManager);
			++dIndex;
		}
	}

	m_pCBluetoothRadioManager = pCBluetoothRadioManager;
}

void CMFC_BLUETOOTH_TESTDlg::OnLbnSelchangeList2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	m_pCBluetoothDeviceManager = NULL;

	CListBox *pList = (CListBox*)GetDlgItem(IDC_LIST2);

	if (!pList->GetSafeHwnd())
		return;

	int pos = pList->GetCurSel();

	if (pos < 0)
		return;

	CBluetoothDeviceManager *pCBluetoothDeviceManager = reinterpret_cast<CBluetoothDeviceManager*>(pList->GetItemDataPtr(pos));

	if (pCBluetoothDeviceManager == NULL)
		return;

	m_pCBluetoothDeviceManager = pCBluetoothDeviceManager;
}
