#pragma once

#include <vector>
#include <algorithm>

#include "BluetoothRadioManager.h"
#include "BluetoothDeviceManager.h"

class CBluetoothManger
{
public:
	CBluetoothManger();
	~CBluetoothManger();

private:
	std::vector<CBluetoothRadioManager*> m_vecRadios;

	void FindRadios(void);

protected:

public:
	size_t GetRadioSize(void);
	CBluetoothRadioManager *GetRadio(size_t pos);
	CBluetoothRadioManager *GetRadio(LPCTSTR pszName);
};

